// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include "ISCW_FMemberReference.h"
#include "ISCW_FProperty.h"
#include "ISCW_UEdGraphNode.h"
#include "ISCW_UK2Node.h"
#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{	
	class ISCW_UK2Node_Variable : public virtual ISCW_UK2Node
	{
	public:
		virtual ~ISCW_UK2Node_Variable() = default;
				
		virtual wstring GetVarName() const = 0;

		virtual ISCW_FPropertyPtr GetPropertyForVariable() const = 0;

		virtual ISCW_FMemberReferencePtr GetVariableReference() const = 0;

		virtual shared_ptr<ISCW_UK2Node_Variable> ToUK2Node_VariablePtr() = 0;
		virtual shared_ptr<const ISCW_UK2Node_Variable> ToUK2Node_VariablePtr() const = 0;
	};

	using ISCW_UK2Node_VariableConstPtr = shared_ptr<const ISCW_UK2Node_Variable>;
	using ISCW_UK2Node_VariablePtr = shared_ptr<ISCW_UK2Node_Variable>;
} // namespace Sourcify